<?php

namespace app\api\controller;

use app\common\controller\Api;
use think\Db;
/**
 * 用户推荐
 */
class Userposter extends Api
{
    protected $noNeedLogin = [];
    protected $noNeedRight = ['*'];


    //二维码海报
    private function mini_code($scene, $page_url, $introcode)
    {
        $value = config('wxMiniProgram');
        $appid = $value['appid'];
        $secret = $value['secret'];
        $url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=' . $appid . '&secret=' . $secret;
        $res = file_get_contents($url);

        $token = json_decode($res, true)['access_token'];
        $URL = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=' . $token;
        $data = [
            'scene' => 'introcode='.$introcode, //二维码传入参数
            'page' => $page_url, //扫码后进入页面
            'env_version' => 'release', //要打开的小程序版本。正式版为 "release"，体验版为 "trial"，开发版为 "develop"。默认是正式版。
            'width' => 800,  //二维码的宽度，单位 px，最小 280px，最大 1280px
            'auto_color' => false, //自动配置线条颜色，如果颜色依然是黑色，则说明不建议配置主色调，默认 false
            'is_hyaline' => false, //是否需要透明底色，为 true 时，生成透明底色的小程序
            'check_path' => false,
        ];
        $json = json_encode($data); //数组加密
        //$result = $this->api_notice_increment($URL, $json); //用CURL 进行POST请求
        $result = curl_post($URL,$json);

        $path  = ROOT_PATH . 'public/uploads/minicode'; //ROOT_PATH 我使用的是TP5框架
        $path2 =                   '/uploads/minicode';

        if (!file_exists($path)) { //判断目录是否存在
            mkdir($path, 0777, true);
        }
        $path  =  $path . '/' . $scene . '.png'; //最后要写入的目录及文件名
        $path2 = $path2 . '/' . $scene . '.png'; //最后要写入的目录及文件名

        file_put_contents($path, $result);

        return $path2;
    }

    //生成视频分享海报
    public function shareposter() {

        $inviteimage = $this->mini_code($this->auth->id,'pages/index/index',$this->auth->introcode);

        $data = [


            [
                "left"=> "100px",
                "top"=> "515px",
                "type"=> "img",
                "width"=> "170px",
                "height"=> "170px",
                "src"=> httpurllocal($inviteimage)//"https://metavision.oss-cn-hongkong.aliyuncs.com/uploads/20220615/f00cb545deb4c4e7296f444239d83e84.jpg"
            ],
            [
                "left"=> "158px",
                "top"=> "490px",
                "type"=> "nickname",
                "width"=> "166px",
                "height"=> "38px",
                "size"=> "13px",
                "color"=> "#2cb47d",
                "content" => $this->auth->introcode,
            ],

        ];


        $data = json_encode($data, 320);

        $poster = [
            'id' => 1,
            'title' => '测试',
            'waittext' => '您的专属海报正在拼命生成中，请等待片刻...',
            'bg_image' => '/assets/img/posteruserbg.png',
            'data' => $data,
            'status' => 'normal',
            'weigh' => 0,
            'createtime' => 1653993709,
            'updatetime' => 1653994259,
        ];

        $image = new \addons\poster\library\Image();
        $imgurl = $image->createPosterImage($poster, $this->auth->getUser());

        if (!$imgurl) {
            $this->error('生成海报出错');
        }
        $imgurl = $_SERVER["REQUEST_SCHEME"]."://".$_SERVER["HTTP_HOST"] . '/' . $imgurl;

//        echo '<html><body><img src="'.$imgurl.'"></body></html>';

        $this->success('', $imgurl);
    }






}
